//3D assignment 
//Woohun Joo

import peasy.*;
PeasyCam cam;

import controlP5.*;
import processing.opengl.*;

ControlP5 cp5;

//checkbox
CheckBox checkbox;
CheckBox checkbox1;
int myColorBackground;

Table table;
int rowNums;

int boxSize = 1200;
boolean lining = false;
boolean lining1 = false;
boolean lining2 = false;
boolean lining3 = false;
boolean lining4 = false;
boolean lining5 = false;
boolean lining6 = false;

boolean text1 = false;
boolean text2 = false;
boolean text3 = false;
boolean mov = false;
boolean rot = true;
boolean dir = false;

//rotating unit
float y = 0.1;

//moving size
float moving = 1.0;
boolean movPos = true;


//book array
ArrayList<Travelbook> books = new ArrayList<Travelbook>();

//font
PFont myFont1;

//dewey
String [] deweyClass = {"EUROPE","ASIA","AFRICA","S.AMERICA","N.AMERICA","ETC"};
//time
String [] timeRange = {"10:00 AM", "11:00 AM", "12:00 PM", "1:00 PM", "2:00 PM", 
                      "3:00 PM", "4:00 PM", "5:00 PM", "6:00 PM", "7:00 PM", "8:00 PM"};
//time
String [] yearRange = {"2010", "2011", "2012", "2013", "2014", "2015"};      



void setup(){
  size(1928, 1024, P3D);
  cam = new PeasyCam(this, 2000);
  //cam.lookAt(frameCount, 0, 0);
  
 
  cp5 = new ControlP5(this);
  cp5.setAutoDraw(false);
  
  //checkbox
  checkbox = cp5.addCheckBox("checkBox")
                .setPosition(60, 130)
                .setSize(10, 10)
                .setItemsPerRow(1)
                .setSpacingColumn(30)
                .setSpacingRow(10)
                .setColorLabel(color(0,0,0))
                .addItem("914: Europe", 0)
                .addItem("915: Asia", 50)
                .addItem("916: Africa", 100)
                .addItem("917: N.America", 150)
                .addItem("918: S.America", 200)
                .addItem("919: Australasia, Pacific, Atlantic Ocean, Arctic islands, Antarctica", 250)
                .addItem("ALL", 300)
                ;
                
    checkbox1 = cp5.addCheckBox("checkBox1")
                .setPosition(60, 280)
                .setSize(10, 10)
                .setItemsPerRow(1)
                .setSpacingColumn(30)
                .setSpacingRow(10)
                .setColorLabel(color(0,0,0))
             
                .addItem("LABEL ON/OFF", 0)
                .addItem("MOTION ON/OFF", 50)
                .addItem("ROTATING", 100)
                ;                

  //font
  myFont1 = createFont("DIN Bold",18);
  
  table = loadTable("total2.csv", "header");
  rowNums = table.getRowCount();
  println("Rows: " + rowNums);
  
  //get table data
  for(int i=0; i<rowNums; i++){
    int dewey = table.getInt(i, 0); //z axis
    String title = table.getString(i, 1); //mouse over
    String date = table.getString(i, 3); //x axis
    String time = table.getString(i, 4); //y axis
    int count = table.getInt(i, 5); //size?
    int keep = table.getInt(i, 7); //color variation
    books.add(new Travelbook(dewey, title, date, time, count, keep));
  }
  
  //print row data
  println("Number of Books: " + books.size());
  println("Dewey: " +books.get(0).dewey);
  println("Title: " +books.get(0).title);
  println("Date: " +books.get(0).date);
  println("Time: " +books.get(0).time);
  println("Checkouts: " +books.get(0).count);
}

//treemap
//controlP5


void draw(){
  
  background(210, 210, 210);
  
  if(rot == true){
  rotateY(frameCount*-0.001);
  }
  
  stroke(255, 0, 0);
  
  //float add = 0.0;
  
  //if(mov == true){
  //moving++;
  //}
  //if(mov == true) {
  //  if(dir == false){
  //    moving++;
  //  }if(dir == true){
  //    moving--;
  //  }
  
  //}
  
  if(mov == true) {
    if(movPos == true) moving++;
    else moving --;
  }
  
  //data parser
  for(int i=0; i<books.size()-1; i++){
    
    //x = date / 2005~2015 / 6 years / week-based
    float dateAxis = map(weekParser(books.get(i).date), 0, 6 * 365 / 7, -boxSize/2, boxSize/2);
    //y = time / 10am ~ 20pm
    float timeAxis = map(timeParser(books.get(i).time), 600, 1200, -boxSize/2, boxSize/2);
    //z = deweyclass
    float deweyAxis = map(books.get(i).dewey, 914, 919, -boxSize/2, boxSize/2);
    //unit width = checkout counts
    float countAxis = map(log(books.get(i).count), log(1), log(170000), 5, 300);
    //unit color = checkout counts

    float colorAxis = map(log(books.get(i).count), log(1), log(170000), 0, 255);
    
    //temp x
    float dateAxis1 = map(weekParser(books.get(i+1).date), 0, 6 * 365 / 7, -boxSize/2, boxSize/2);
    //temp y
    float timeAxis1 = map(timeParser(books.get(i+1).time), 600, 1200, -boxSize/2, boxSize/2);
    ////temp z
    float deweyAxis1 = map(books.get(i+1).dewey, 914, 919, -boxSize/2, boxSize/2);
    
    //unit color
    colorMode(HSB, 360, 100, 100);
    color c = unitColor(books.get(i).dewey);
    
    colorMode(RGB, 255, 255, 255);
    //unit color and transparency
    //255 opaque, 0 transparent , rgb, alpha
    if(books.get(i).dewey == 914){
      fill(255, colorAxis, 0, 230);
    } else if(books.get(i).dewey == 915){
      fill(colorAxis, 255, 0, 230);
    } else if(books.get(i).dewey == 916){
      fill(0,colorAxis, 255, 230);
    } else if(books.get(i).dewey == 917){
      fill(colorAxis, 100, 255, 230);
    } else if(books.get(i).dewey == 918){
      fill(60, 100, colorAxis+50, 230);
    } else if(books.get(i).dewey == 919){
      fill(320, 100, colorAxis, 230);
    }
     
    //unit stroke, strokeweight, fillcolor
    strokeWeight(0.5);
    stroke(c);
    //fill();
    colorMode(RGB, 255, 255, 255);
    
    pushMatrix();
    
    if(timeAxis <= boxSize/2 & timeAxis >= -boxSize/2 
      & dateAxis <= boxSize/2 & dateAxis >= -boxSize/2
      & deweyAxis <= boxSize/2 & deweyAxis >= -boxSize/2
      & countAxis <= boxSize/2 & countAxis >= -boxSize/2){
      translate(dateAxis, timeAxis, deweyAxis);
      
      //moving unit size
      if(moving > countAxis*4) movPos = false;
      if(moving < 3) movPos = true;
      
      box(10, 10, countAxis+moving); //w, h, d
    }
    popMatrix();
    
    //connecting line stroke
    strokeWeight(0.5);
    
    
    //line
    if(lining == true){
      stroke(50);
      line(dateAxis, timeAxis, deweyAxis, dateAxis1, timeAxis1, deweyAxis1);
    }else if(lining1 == true & books.get(i).dewey == 914){
      stroke(255, 0, 0);
      line(dateAxis, timeAxis, deweyAxis, dateAxis1, timeAxis1, deweyAxis1);
    }else if (lining2 == true & books.get(i).dewey == 915){
      stroke(0, 255, 0);
      line(dateAxis, timeAxis, deweyAxis, dateAxis1, timeAxis1, deweyAxis1);
    }else if (lining3 == true & books.get(i).dewey == 916){
      stroke(0, 150, 255);
      line(dateAxis, timeAxis, deweyAxis, dateAxis1, timeAxis1, deweyAxis1);
    }else if (lining4 == true & books.get(i).dewey == 917){
      stroke(0, 170, 255);
      line(dateAxis, timeAxis, deweyAxis, dateAxis1, timeAxis1, deweyAxis1);
    }else if (lining5 == true & books.get(i).dewey == 918){
      stroke(43, 0, 255);
      line(dateAxis, timeAxis, deweyAxis, dateAxis1, timeAxis1, deweyAxis1);
    }else if (lining6 == true & books.get(i).dewey == 919){
      stroke(255, 0, 170);
      line(dateAxis, timeAxis, deweyAxis, dateAxis1, timeAxis1, deweyAxis1);
    } 
  }
  
  //text dewey
  for(int dw=0; dw<6; dw++){
    if(dw==0){
      fill(255, 0, 0);
    }else if(dw==1){
      fill(0, 160, 0);
    }else if(dw==2){
      fill(0, 97, 255);
    }else if(dw==3){
      fill(0, 170, 255);
    }else if(dw==4){
      fill(43, 0, 255);
    }else if(dw==5){
      fill(255, 0, 170);
    }
    textFont(myFont1);
    textAlign(LEFT, CENTER);
    
    if(text1 == true){
    text(deweyClass[dw], boxSize/2 + 10, boxSize/2, (boxSize/5)*dw-(boxSize/2));
    }
  }
  //text time
  for(int tm=0; tm<11; tm++){
    textFont(myFont1);
    textAlign(LEFT, CENTER);
    fill(0, 0, 0);
    if(text2 == true){
    text(timeRange[tm], -boxSize/2 - 90, (-boxSize/10)*tm+(boxSize/2), boxSize/2);
    }
  }
  //text year
  for(int yr=0; yr<6; yr++){
    textFont(myFont1);
    textAlign(LEFT, CENTER);
    fill(0, 0, 0);
    if(text3 == true){
    text(yearRange[yr], (boxSize/5)*yr-(boxSize/2), boxSize/2 + 50, boxSize/2);  
    }
  }
  
  //big box stroke
  //strokeWeight(5);
  noStroke();
  //stroke(255, 0, 0, 255);
  //inner cube
  noFill();
  box(boxSize);
  gui();
  
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

void checkBox(float[] a) {
  println(a);
}